package com.rthoni.camotion.ui.fragments;

import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.Toast;

import com.luticate.utils.business.LuPromise;
import com.rthoni.camotion.R;
import com.rthoni.camotion.business.CamerasBusiness;
import com.rthoni.camotion.dbo.CameraDbo;
import com.rthoni.camotion.ui.views.CameraView;

/**
 *
 * Created by robin on 11/29/15.
 */
public class CamerasFragment extends CamotionFragment {

    private CameraDbo.MultipleCameraDbo _cameras = null;

    private int _page = 0;

    private int _perPage = 6;

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState)
    {
        View rootView = inflater.inflate(R.layout.cameras_layout, container, false);
        return rootView;
    }

    @Override
    public void onResume() {
        super.onResume();
        if (_cameras == null) {
            showProgress(true);
            CamerasBusiness.getAll(_currentLocation.getConfig(_fullLoginDbo.getLoginDbo()), _page, _perPage)
                    .then(new LuPromise.LuConsumer<CameraDbo.MultipleCameraDbo>() {
                        @Override
                        public void execute(CameraDbo.MultipleCameraDbo data) {
                            _cameras = data;

                            LinearLayout layout = (LinearLayout) getView().findViewById(R.id.imagesLayoutScrollView);

                            for (CameraDbo camera : _cameras.getData())
                            {
                                CameraView imageView = new CameraView(getActivity());
                                imageView.setCamotionDbo(_fullLoginDbo, _currentLocation);
                                imageView.setCamera(camera);
                                imageView.togglePlay();
                                layout.addView(imageView);
                            }

                            showProgress(false);
                        }
                    }, new LuPromise.LuConsumer<LuPromise.LuPromiseError>() {
                        @Override
                        public void execute(LuPromise.LuPromiseError error) {
                            Toast.makeText(getActivity(), error.toString(), Toast.LENGTH_LONG).show();
                            showProgress(false);
                        }
                    });
        }
    }
}
