package com.rthoni.camotion.ui.fragments;

import android.animation.Animator;
import android.animation.AnimatorListenerAdapter;
import android.app.Fragment;
import android.os.Build;
import android.view.View;

import com.luticate.auth.dbo.LuFullLoginDbo;
import com.rthoni.camotion.R;
import com.rthoni.camotion.dbo.LocationDbo;

/**
 * Created by robin on 12/3/15.
 */
public abstract class CamotionFragment extends Fragment {
    protected LuFullLoginDbo _fullLoginDbo = null;
    protected LocationDbo _currentLocation = null;

    public void setCamotionDbo(LuFullLoginDbo fullLoginDbo, LocationDbo currentLocation)
    {
        _fullLoginDbo = fullLoginDbo;
        _currentLocation = currentLocation;
    }

    protected void showProgress(final boolean show)
    {
        View v = getView();
        if (!isAdded() || v == null)
            return;

        final View imagesScrollView = v.findViewById(R.id.mainScrollView);
        final View loadingView = v.findViewById(R.id.loadStatus);

        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.HONEYCOMB_MR2)
        {
            int shortAnimTime =
                    getResources().getInteger(android.R.integer.config_shortAnimTime);

            loadingView.setVisibility(View.VISIBLE);
            loadingView.animate().setDuration(shortAnimTime).alpha(show ? 1 : 0)
                    .setListener(new AnimatorListenerAdapter()
                    {
                        @Override
                        public void onAnimationEnd(Animator animation)
                        {
                            loadingView.setVisibility(show ? View.VISIBLE : View.GONE);
                        }
                    });

            imagesScrollView.setVisibility(View.VISIBLE);
            imagesScrollView.animate().setDuration(shortAnimTime).alpha(show ? 0 : 1)
                    .setListener(new AnimatorListenerAdapter()
                    {
                        @Override
                        public void onAnimationEnd(Animator animation)
                        {
                            imagesScrollView.setVisibility(show ? View.GONE : View.VISIBLE);
                        }
                    });
        }
        else
        {
            loadingView.setVisibility(show ? View.VISIBLE : View.GONE);
            imagesScrollView.setVisibility(show ? View.GONE : View.VISIBLE);
        }
    }
}
